import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/do';
import 'rxjs/add/observable/throw';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
export declare class BaseApi {
    protected http: HttpClient;
    constructor(http: HttpClient);
    private _loading;
    /** 是否正在加载中 */
    readonly loading: boolean;
    private static parseParams(params);
    private static parseHeaders(headers);
    private begin();
    private end();
    get(url: string, params?: any, headers?: any): Observable<any>;
    post(url: string, body?: any, params?: any, headers?: any): Observable<any>;
    put(url: string, body?: any, params?: any, headers?: any): Observable<any>;
    delete(url: string, params?: any, headers?: any): Observable<any>;
    private down(url, body?);
    private downLoad(url, type, body?, fileName?);
    /**
     *  下载excel表格
     * @param {string} url
     * @param body
     * @param {string} fileName
     * @returns {Observable<boolean>}
     */
    downLoadXlsx(url: string, body?: any, fileName?: string): Observable<boolean>;
    /**
     *  下载pdf， 如果不传入文件名会再浏览器中打开 实现打印功能
     *  传入文件名会直接下载
     * @param {string} url
     * @param body
     * @param {string} fileName
     * @returns {Observable<boolean>}
     */
    downLoadPdf(url: string, body?: any, fileName?: string): Observable<boolean>;
    protected abpGet<T>(url: string, params?: any): Observable<any>;
    protected abpPost<T>(url: string, body?: any, params?: any): Observable<any>;
    private static process<T>(r);
}
export declare class Result {
    success: boolean;
    error: any;
    result: any;
    constructor();
}
